<template>
  <ion-page>
    <page-top-bar
      :needBackButton="true"
      :title="`${t(
        'feedback_and_support_page.feedback_support',
        {},
        { locale: $store.state.appLang }
      )}`"
    />
    <!-- TODO fix error happening when displaying the title on a screen that is not wide enough -->
    <ion-content>
      <div class="p-5 mt-5">
        <ion-text class="flex text-center">
          {{
            t(
              "feedback_and_support_page.page_description",
              {},
              { locale: $store.state.appLang }
            )
          }}
        </ion-text>
        <ion-item class="border mt-5">
          <ion-select
            :placeholder="
              t(
                'feedback_and_support_page.feedback_type',
                {},
                { locale: $store.state.appLang }
              )
            "
            interface="action-sheet"
            v-model="feedbackType"
          >
            <ion-select-option value="BUG">
              {{
                t(
                  "feedback_and_support_page.report_bug",
                  {},
                  { locale: $store.state.appLang }
                )
              }}
            </ion-select-option>
            <ion-select-option value="SUGGESTION">
              {{
                t(
                  "feedback_and_support_page.make_suggestion",
                  {},
                  { locale: $store.state.appLang }
                )
              }}
            </ion-select-option>
            <ion-select-option value="LOVE">
              {{
                t(
                  "feedback_and_support_page.love_declaration",
                  {},
                  { locale: $store.state.appLang }
                )
              }}
            </ion-select-option>
            <ion-select-option value="OTHER">
              {{
                t(
                  "feedback_and_support_page.other_feedback",
                  {},
                  { locale: $store.state.appLang }
                )
              }}
            </ion-select-option>
          </ion-select>
        </ion-item>
        <div class="pl-2 border mt-5">
          <ion-input
            v-model="titleTextAreaContent"
            auto-grow
            :placeholder="`${t(
              'feedback_and_support_page.message_title',
              {},
              { locale: $store.state.appLang }
            )}`"
          />
        </div>

        <div class="pl-2 border mt-5">
          <ion-textarea
            v-model="descriptionTextAreaContent"
            auto-grow
            :placeholder="`${t(
              'feedback_and_support_page.message_description',
              {},
              { locale: $store.state.appLang }
            )}`"
          />
        </div>
        <div class="flex justify-center pt-3">
          <ion-button
            :disabled="
              !(
                titleTextAreaContent &&
                descriptionTextAreaContent &&
                feedbackType
              )
            "
            @click="publish"
          >
            {{ t("actions.send", {}, { locale: $store.state.appLang }) }}
          </ion-button>
        </div>
      </div>
    </ion-content>
  </ion-page>
</template>

<script>
import feedbackService from "../services/feedback";
import {
  IonPage,
  IonContent,
  IonTextarea,
  IonItem,
  IonText,
  IonSelect,
  IonSelectOption,
  IonInput,
  IonButton,
  alertController,
} from "@ionic/vue";
import PageTopBar from "../components/PageTopBar";
import { send } from "ionicons/icons";
import { defineComponent, ref } from "vue";
import { useI18n } from "vue-i18n";

export default defineComponent({
  name: "FeedbackAndSupport",
  setup() {
    const { t, locale } = useI18n();
    const titleTextAreaContent = ref("");
    const descriptionTextAreaContent = ref("");
    const feedbackType = ref("");
    return {
      t,
      locale,
      send,
      titleTextAreaContent,
      feedbackType,
      descriptionTextAreaContent,
    };
  },
  components: {
    IonPage,
    IonContent,
    IonTextarea,
    PageTopBar,
    IonItem,
    IonText,
    IonSelect,
    IonSelectOption,
    IonInput,
    IonButton,
  },
  methods: {
    async publish() {
      const feedback = {
        title: this.titleTextAreaContent,
        message: this.descriptionTextAreaContent,
        category: this.feedbackType,
      };
      try {
        const response = await feedbackService.send(feedback);
        if (response.status === 200) {
          await this.confirmMessage();
        } else {
          await this.openErrorToast();
        }
      } catch (error) {
        await this.openErrorToast();
      }
    },
    async confirmMessage() {
      const alert = await alertController.create({
        message:
          "<strong>" +
          this.t(
            "feedback_and_support_page.confirm_message",
            {},
            { locale: this.$store.state.appLang }
          ) +
          "</strong>",
        buttons: [
          {
            text: this.t("actions.ok", {}, { locale: this.$store.state.appLang }),
            handler: () => {
              this.$router.push({ name: "Home" });
            },
          },
        ],
        backdropDismiss: false,
      });
      return alert.present();
    },
  },
});
</script>

<style scoped>
</style>
